package animals;

//     ,      .
class Cat extends Animal {
    //    ,     
    private static final int MAX_CATS = 2;
    //     .
    public static int getTotalCats() {
        return totalCats;
    }
    private static int totalCats = 0;
    
    //      private,      
    //      Cat.      
    //  CreateCats   overloads
    private Cat(String name) throws AnimalException {
        super(name);
    }
    private Cat(String name, boolean isAsleep) throws AnimalException {
        super(name, isAsleep);
    }
    
    //             ,
    //      Cat       
    // ,    "  ".   Cat Factory.
    public static Cat createCat(String name) throws AnimalException {
        return createCat(name, false);
    }
    public static Cat createCat(String name, boolean isAsleep) throws AnimalException {
        //    totalCats
        if (totalCats + 1 > MAX_CATS)
            throw new AnimalException("  !");
        
        Cat cat = new Cat(name, isAsleep);
        
        totalCats++;
        
        return cat;
    }
    
    //   Sound   ISoundable 
    //         Animal
    public void sound() {
        System.out.println("!");
    }
}